/*
 * WEB Thermometer (CGI HTTP interface)
 *
 *  Copyright (C) 1999-2001  Claudio Lanconelli
 *
 *  e-mail: lancos@libero.it
 *  http://www.LancOS.com
 *
 *  $Id: cgi_therm.cpp,v 1.5 2002/03/24 07:26:56 lanconel Exp $
 */

//-------------------------------------------------------------------------//
//                                                                         //
// This program is free software; you can redistribute it and/or           //
// modify it under the terms of the GNU  General Public License            //
// as published by the Free Software Foundation; either version2 of        //
// the License, or (at your option) any later version.                     //
//                                                                         //
// This program is distributed in the hope that it will be useful,         //
// but WITHOUT ANY WARRANTY; without even the implied warranty of          //
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU       //
// General Public License for more details.                                //
//                                                                         //
// You should have received a copy of the GNU  General Public License      //
// along with this program (see COPYING);     if not, write to the         //
// Free Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA. //
//                                                                         //
//-------------------------------------------------------------------------//

#include <stdio.h>
#include <string.h>

#include <stdlib.h>

#include "../readtemp.h"

typedef char **stringArray;
extern int getnamevalue(stringArray *name,
           stringArray *value);
extern void delnamevalue(stringArray name,
           stringArray value, int num);

#define	MAXLINESIZE	1024
static char line_buffer[MAXLINESIZE];

#define	RESULT_TAG	"'RESULTS'"
#define	RESULT_SIZE	strlen(RESULT_TAG)

#define	RELOAD_TAG	"'RELOAD_TIME'"
#define	RELOAD_SIZE strlen(RELOAD_TAG)

static char *html_head =
"<html><head><title>WEB Thermometer</title>"
"<! Author :    Claudio Lanconelli ->"
"<meta http-equiv=""Refresh"" content=""'RELOAD_TIME'"">"
"<meta name=""description"" content=""LancOS WEB Thermometer"">"
"<meta name=""keywords"" content=""claudio, lanconelli, LancOS, WEB, thermometer"">"
"</head><body>"
"<p align=""center""><font color=""#000080""><strong><big><big>WEB Thermometer</big></big><br>"
"<big><big>by <em>LancOS</big></big><br>"
"</em></strong></font><a href=""http://www.lancos.com"">http://www.LancOS.com</a></p>"
"<hr><p align=""center""><big><big><big><big><strong><font color=""#800000"">";

static char *html_tail =
"</font></strong></big></big></big></big></p><hr>"
"</body></html>";


int main(void)
{
	int i, num;
	stringArray name;  /* name[i]  is a char string */
	stringArray value; /* value[i] is a char string */

	FormatType format = fTEXT;
	UnitType unit = uCELSIUS;
	int first = 1;
	int last = 1;
	int port = 0;
	int reload_time = 0;
	int digits = 1;
	long delay = 0;

	char *sp = getenv("THERM_PORT");
	if (sp != NULL)
		port = atoi(sp);

	num = getnamevalue(&name, &value);

	for(i=0; i < num; i++)
	{
	/*	printf("%s=%s\n",name[i],value[i]); */
		if ( strcmp(name[i], "format") == 0 )
		{
			if (strcmp(value[i], "html") == 0)
				format = fHTML;
		}
		else
		if ( strcmp(name[i], "unit") == 0 )
		{
			if (strcmp(value[i], "far") == 0)
				unit = uFARENHEIT;
		}
		else
		if ( strcmp(name[i], "what") == 0 )
		{
			sscanf(value[i], "%d-%d", &first, &last);
			if (first < 1 || first > N_THERM)
				first = 1;
			if (last < 1 || last > N_THERM)
				last = 1;
			if (last < first)
				last = first;
		}
		else
		if ( strcmp(name[i], "port") == 0 && port == 0 )
		{
			port = atoi(value[i]);
		}
		else
		if ( strcmp(name[i], "reload") == 0 )
		{
			reload_time = atoi(value[i]);
		}
		else
		if ( strcmp(name[i], "digits") == 0 )
		{
			digits = atoi(value[i]);
		}
		else
		if ( strcmp(name[i], "delay") == 0 )
		{
			delay = atol(value[i]);
		}
	}
	delnamevalue(name, value, num);

	if (reload_time < 2 || reload_time > 50000)
		reload_time = 5;		//Default is 5 secs

	if (port == 0)
		port = 3;

	if (delay < 1 || delay > 1000000)
		delay = 50;

	SetI2CDelay(delay);
	sp = ReadTemperature(format, unit, digits, first, last, port);

	if (format == fHTML)
	{
		printf("Content-type: text/html\n\n");

		FILE *fh = fopen("skeleton.html", "r");
		if (fh == NULL)
		{
			printf("%s\n", html_head);

			if (sp == NULL)
			{
				printf("Error\n");
			}
			else
				printf("%s\n", sp);

			printf("%s\n", html_tail);
		}
		else
		{
			while ( fgets(line_buffer, MAXLINESIZE, fh) != NULL )
			{
				char *s = strchr(line_buffer, '\'');
				if (s != NULL && strncmp(s, RESULT_TAG, RESULT_SIZE) == 0 )
				{
					*s = '\0';
					printf("%s", line_buffer);	//Print head of the line

					if (sp == NULL)			//Print result
					{
						printf("Error");
					}
					else
						printf("%s", sp);

					s += RESULT_SIZE;
					printf("%s", s);	//Print tail of the line
				}
				else
				if (s != NULL && strncmp(s, RELOAD_TAG, RELOAD_SIZE) == 0 )
				{
					*s = '\0';
					printf("%s", line_buffer);	//Print head of the line

					printf("%d", reload_time);

					s += RELOAD_SIZE;
					printf("%s", s);	//Print tail of the line
				}
				else
					printf("%s", line_buffer);
			}
		}
	}
	else
	{
		printf("Content-type: text/plain\n\n");
		if (sp == NULL)
			printf("Error\n");
		else
			printf("%s\n", sp);
	}

	return 0;
}

